{- This .hs-boot file breaks the circular dependency between the modules
   Subtyping and Environment. This dependency arises because we check
   the restrictions on type environments (which involves subtyping)
   directly when constructing a type environment, so these checks
   must be placed in the environment module. On the other side, subtying
   depends necessesarily on the type environment.
-}
module Environment where

import Data.Set (Set)
import AST
import Pretty

data TEnv

upperBounds :: TyvarName -> TEnv -> [Type]
supImplCons :: TEnv -> Set ConGR
monoVars :: TEnv -> Set TyvarName

instance Pretty TEnv