/* Expected output:
Model changed!
*/
interface ObserverPattern [Subject, Observer] {
  receiver Subject {
    void register(Observer o);
    void notify();
  }
  receiver Observer {
    void update(Subject s);
  }
}

class Model {
  Display observer;
}

class Display {
}

implementation ObserverPattern [Model, Display] {
  receiver {
    void register(Display o) {
      this.observer = o;
    }
    
    void notify() {
      this.observer.update(this);
    }
      
  }

  receiver {
    void update(Model m) {
      print("Model changed!");
    }
  }
}

class MultiheadTest {
  <S,O> void genericUpdate(S subject, O observer) 
    where [S,O] implements ObserverPattern {
    subject.register(observer);
    observer.update(subject);
  }
}

class Main {
  void main() {
    MultiheadTest mt = new MultiheadTest();
    mt.genericUpdate<Model,Display>(new Model(), new Display()); // should print ``Model changed!''
  }
}
