/*
Type error: method signatures ``QueryResult exec(Object x_1)'' and ``QueryResult exec(String x_1)'' have mismatched arguments
*/

/*
 Should fail because implementation of exec in implementation definition
   Connection[MySQLConnection] has the wrong type. 
*/

class QueryResult {
  String id;
  QueryResult(String id) {
    this.id = id;
  }
}

class Customer {
}

interface Connection {
  QueryResult exec(String command);
}

class UseConnection {
  QueryResult newCustomer(Connection con, Customer customer) {
    String command = "INSERT ... INTO customer";
    return con.exec(command);
  }
}

class MySQLConnection {
  QueryResult execCommand(String command) {
    return new QueryResult("MySQLConnection: " + command);
  }
}

implementation Connection [MySQLConnection] {
  QueryResult exec(Object command) {
    return this.execCommand( (String) command);
  }
}

class Main {
  void main() {
    MySQLConnection conn = new MySQLConnection();
    Customer someCustomer = new Customer();
    QueryResult res = new UseConnection().newCustomer(conn, someCustomer);
    print(res);
  }
}
