/*

Type error: no method "compareTo" found for receiver type ``LinkedList<String>'' and argument types ``LinkedList<String>''

*/
interface GIComparable {
  int compareTo(This that);
}

class LinkedList<X> {
  Node<X> head;
  LinkedList(Node<X> head) {
    this.head = head;
  }
}

class Node<X> {
  X value;
  Node<X> next;
  Node(X value, Node<X> next) {
    this.value = value;
    this.next = next;
  }
}

implementation<X> GIComparable [LinkedList<X>] where X implements GIComparable {
  int compareTo(LinkedList<X> that) {
    Node<X> cur1 = this.head;
    Node<X> cur2 = that.head;
    while (cur1 != null && cur2 != null) {
      X val1 = cur1.value;
      X val2 = cur2.value;
      int i = val1.compareTo(val2);
      if (i != 0) return i;
      cur1 = cur1.next;
      cur2 = cur2.next;
    }
    if (cur1 != null && cur2 == null) return 1;
    if (cur1 == null && cur2 != null) return -1;
    return 0;
  }
}

implementation GIComparable [Integer] {
  int compareTo(Integer that) {
    if (this.intValue() < that.intValue()) return -1;
    else if (this.intValue() == that.intValue()) return 0;
    else return 1;
  }
}

class Main {
  void main() {
    LinkedList<String> l1 = 
      new LinkedList<String>(new Node<String>("1", new Node<String>("2", null)));
    LinkedList<String> l2 = 
      new LinkedList<String>(new Node<String>("1", null));
    printInt(l1.compareTo(l1)); // should print 0
    printInt(l1.compareTo(l2)); // should print 1;
    printInt(l2.compareTo(l1)); // should print -1;
  }
}
                                                     
