/*

Type error: method signatures ``void register(Data x_1)'' and ``void register(Display x_1)'' have mismatched arguments

*/

interface ObserverPattern [Subject, Observer] {
  receiver Subject {
    void register(Observer o);
    void notify();
  }
  receiver Observer {
    void update(Subject s);
  }
}

class Model {
  Display observer;
}

class Display {
}

class Data {
}

implementation ObserverPattern [Model, Display] {
  receiver {
    void register(Data o) {
      this.observer = (Display) o;
    }
    
    void notify() {
      this.observer.update(this);
    }
      
  }

  receiver {
    void update(Model m) {
      print("Model changed!");
    }
  }
}

class MultiheadTest {
  <S,O> void genericUpdate(S subject, O observer) 
    where [S,O] implements ObserverPattern {
    observer.update(subject);
  }
}

class Main {
  void main() {
    MultiheadTest mt = new MultiheadTest();
    mt.genericUpdate<Model,Display>(new Model(), new Display());
  }
}
